<?php
/**
* @version 00.04.03
* @package polaring
* @license This component in released under the GNU/GPL License
*
* File: functions/directoryFunctions.php
* Role: Related to finding and reading exercises in `exercise-dir'.
*
* File is as good as copied from `polarphp', found at:
* http://users.pandora.be/oppiekes/polar
**/

/*

Description:	directory functions
Functions:	getFilesInDirectory(directory,filetype)
		getFilesInDirectoryFull($directory,filetype,filename)
		getFileNames(files,length)

*/

function getFilesInDirectory($dir, $fileTypes) {
	$files = array();
	$validFTypes = explode(", ", $fileTypes);
	$stack[] = $dir;
	while ($stack) {
	  $current_dir = array_pop($stack);
	  if ($dh = opendir($current_dir)) {
	    while (($file = readdir($dh)) !== false) {
	      if ($file !== '.' AND $file !== '..') {
		$current_file = "{$current_dir}/{$file}";
		if (is_file($current_file)) {
			$fExtension = substr(strtolower($file), strlen($file) - 3);
			if ( in_array($fExtension, $validFTypes) ) {
				$files[] = "$current_dir/$file";
			}
		} elseif (is_dir($current_file)) {
			$stack[] = $current_file;
		} 
	      }
	    }
	  }
	}
	return $files;
}

	

function getFileNames($files) { 
	$names = array();
	foreach ($files as $file) {
		$fileInfo = pathinfo($file);
		if ($fileInfo['extension'] == "srd") {
			$dates[] = getDirectoryOfFile($file);
		} elseif ($fileInfo['extension'] == "hrm") {
			$dates[] = substr($file,-12,4);
		} 
	}
	$datesNew = array();
	foreach ($dates as $dateYM) {
		if (in_array($dateYM,$datesNew)) {
			
		} else {
			$datesNew[] = $dateYM;
		}
	}
	rsort($datesNew);
	return $datesNew;
}

function getFilesForMonth($files,$year,$month) { 
	$newFiles = array();
	foreach ($files as $file) {
		$fileInfo = pathinfo($file);
		if ($fileInfo['extension'] == "srd") {
			if (substr(dirname($file),-2,2) == $month && substr(dirname($file),-7,4) == $year) {
				$newFiles[] = $file;
			}
		} elseif ($fileInfo['extension'] == "hrm" ) {
			$yearShort = substr($year,2,2);
			$fileName = substr(baseName($file),0,4);
			if ($fileName == $yearShort.$month) {
				$newFiles[] = $file;
			} 
		} 
	}
	return $newFiles;
}

function getDirectoryOfFile($file) {
	$filePath = dirname($file);
	$month = substr($filePath,-2,2);
	$year = substr($filePath,-5,2);
	$dateYearMonth = $year.$month;
	return $dateYearMonth;
}
?>
