<?php
/**
* @version 00.04.03
* @package polaring
* @license This component in released under the GNU/GPL License
*
* File: functions/general.php
* Role: General functions and variables
**/


/////////////////////////////////////
// READ ESSENTIAL FILES
/////////////////////////////////////

require($_SESSION['dirMain'].'/functions/database.php');
require($_SESSION['dirMain'].'/functions/directoryFunctions.php');
require($_SESSION['dirMain'].'/functions/strings.php');
require($_SESSION['dirMain'].'/functions/strmanip.php');
require($_SESSION['dirMain'].'/functions/errorCheck.php');
require($_SESSION['dirMain'].'/functions/units.php');
require($_SESSION['dirMain'].'/functions/user.php');
require($_SESSION['dirMain'].'/functions/fileFunctions.php');

// Parsers
require($_SESSION['dirMain'].'/functions/hrmParser.php');
require($_SESSION['dirMain'].'/functions/hrmWriteFunctions.php');
require($_SESSION['dirMain'].'/functions/garminParser.php');
require($_SESSION['dirMain'].'/functions/parserFunctions.php');
require($_SESSION['dirMain'].'/functions/srdParser.php');
require($_SESSION['dirMain'].'/functions/xmlparser.php');



/////////////////////////////////////
// FUNCTIONS
/////////////////////////////////////


function checkHomeShow() {
    // Right now, I don't want to show home at all...
    return(false);

    $showCount = 0;
    $possibs = array("tools", "settings", "diary");
    foreach ( $possibs as $pos ) {
	if ( user::validateIP($_SESSION['validIp'][$pos]) ) {
	    $showCount += 1;
	}
    }
    if ( $showCount >= 1 ) {
	return(true);
    } else {
	return(false);
    }
} // end checkHomeShow


function checkWorkouts() {
    if ( ($_GET['mission'] == "monthen" || 
	$_GET['mission'] == "day" ||
	$_GET['mission'] == "graf") && 
	!isset($_SESSION['workouts']) ) {
	    errorCheck::dirExists($_SESSION['dirTrFiles'], 
		strings::expression("setup", "dirWorkouts"));
	    initWorkouts();
	}
    return(true);
} // end checkWorkouts


function checkGmaps() {
    if ( $_SESSION['gmapsApi'] != "" &&
	$_REQUEST['mission'] === "day" &&
	$_GET['dateTime'] ) {
	    $dateTime = $_REQUEST['dateTime'];
	    $selected = fileFunctions::selectFullWorkout($dateTime);
	    if ( $selected['sampleLocationLat']['0'] ) {
		$_SESSION['showGmaps'] = true;
	    } else {
		$_SESSION['showGmaps'] = false;
	    }
	}
    return(true);
} // end function checkGmaps


function initWorkouts() {
    set_time_limit(0);
    $_SESSION['workouts'] = fileFunctions::readWorkoutDir($_SESSION['dirTrFiles'], "hrm, srd, hst");

    if ( count($_SESSION['workouts']) == "0" ) {
	echo "<h2>".strings::expression("error", "Error")."</h2>\n".
	    "<p>".strings::expression("error", "noWorkouts")."<br />\n".
	    "<p>".strings::expression("error", "checkSettings")."</p>";
	die();
    }
    
    $yearMonth = give::yearsMonths($_SESSION['workouts']);
    foreach ( $yearMonth as $key ) {
	$wDate = mktime(0, 0, 0, substr($key,2,2), 1, substr($key,0,2));
	$year = date("Y",$wDate);
	$month = date("m",$wDate);
	$monthData[$key] = give::dataMonth($year, $month);
    }
    $_SESSION['monthData'] = $monthData;
    return(true);
} // end initWorkouts

function hrFilter ($workout) {
  $hrMaxlimit = 193;
  $hrMinlimit =  40;
  $j = 0;
  $sampleTypes = sampleTypes();
		       
  for ( $i = 0; $i < $workout['numberOfSamples']; $i++ ) {
    if ( $workout['sampleHr'][$i] < $hrMaxlimit &&
	 $workout['sampleHr'][$i] > $hrMinlimit ) {
      foreach ( $sampleTypes as $sampleType ) {
	$w[$sampleType][$j] = $workout[$sampleType][$i];
      }
       $j++;
    }
  }
  foreach ( $sampleTypes as $sampleType ) {
    $workout[$sampleType] = $w[$sampleType];
  }
  $workout['numberOfSamples'] = $j;

  return $workout;
} // end function hrFilter


function makeSecond($tid) {
  $data = explode(":", $tid);
  $hour = 60 * (60 * $data['0']);
  $minut = 60 * $data['1'];
  $second = $data['2'];
  $tot_sec = $hour + $minut + $second;
  $seconds = $data['2'] + (60 * $data['1']) + (60 * 60 * $data['0']);
  //return $tot_sec;
  return $seconds;
} // end makeSecond


function giveWeekDay($dayNr) {
	switch( $dayNr ) {
		case '0':
		  $daySt = strings::expression("common", "sunday");
		  break;
		case '1':
		  $daySt = strings::expression("common", "monday");
		  break;
		case '2':
		  $daySt = strings::expression("common", "tuesday");
		  break;
		case '3':
		  $daySt = strings::expression("common", "wednesday");
		  break;
		case '4':
		  $daySt = strings::expression("common", "thursday");
		  break;
		case '5':
		  $daySt = strings::expression("common", "friday");
		  break;
		case '6':
		  $daySt = strings::expression("common", "saturday");
		  break;
	}
	return($daySt);
}

function dieError($mess) {
  //echo "<p>".$mess."</p>\n";
} // end function dieError


function sampleTypes() {
  $sampleTypes = array(
		       //"sampleTime",
		       "sampleHr",
		       //"sampleSpeed",
		       //"sampleDistance",
		       //"sampleCadence",
		       //"sampleAltitude",
		       //"samplePower",
		       //"samplePowerPedallingIndex",
		       //"samplePowerLeftRightBalance",
		       //"samplePowerLeftRightBalance",
		       //"sampleAirPressure"
		       );
 return $sampleTypes;
} // END function sampleTypes



function srdTohrm($fileinfo) {
  $hrmfile = $_SESSION['dirMain']."/temp/workout.hrm";
  $origfile = $fileinfo['dirname']."/".$fileinfo['basename'];

  if ( $fileinfo['extension'] == "hrm" ) {
    return getHrmComplete($origfile);
  } else {
    if ( file_exists($hrmfile) ) {
      unlink($hrmfile);
    }
    exec($_SESSION['dirS710']."/srd2hrm -f ".$origfile." >> ".$hrmfile);

    if ( filesize($hrmfile) == "0" ) {
      $workout = 0;
    } else {
      $workout = getHrmComplete($hrmfile);
    }

    if ( file_exists($hrmfile) ) {
      unlink($hrmfile);
    }

    return $workout;
  }

} // end function srdTohrm


class give {
  
  function yearsMonths($files) {
	  $yearsMonthsRaw = array();
	  foreach ( array_keys($files) as $wDate ) {
		  $yearsMonthsRaw[] = substr($wDate, 2, 4);
	  }
	  $yearsMonths = array_filter(array_unique($yearsMonthsRaw));
	  krsort($yearsMonths);
	  return($yearsMonths);
  } // end function yearMonths


  function yearMonthWorkouts($files, $year, $month) {
	  $selected = array();
	  foreach ( array_keys($files) as $wDate ) {
		  $wYearMonth = substr($wDate, 0, 6);
		  $yearMonth = $year.$month;
		  if ( $wYearMonth == $yearMonth ) {
			  $selected[] = $files[$wDate];
		  }
	  }
	  return($selected);
  } // end function yearMonthWorkouts


  function dataMonth($year, $month) {
      $selected = give::yearMonthWorkouts($_SESSION['workouts'], $year, $month);

      $i = 0;
      $iDis = 0;
      $iSpe = 0;
      $iEne = 0;
      $iHrt = 0;
      $iTmp = 0;

      foreach($selected as $workout) {
	  if ( $workout['distance'] > 0 ) {
	      $iDis++;
	  }
	  if ( $workout['speedAvg'] > 0 ) {
	      $iSpe++;
	  } 
	  if ( $workout['energy'] > 0 ) {
	      $iEne++;
	  }
	  if ( $workout['hrAvg'] > 0 ) {
	      $iHrt++;
	  }
	  if ( $workout['tempAvg'] > 0 ) {
	      $iTmp++;
	  }

	  $total['amount'] = count($selected);
	  $total['amountDis'] = $iDis;
	  $total['amountSpe'] = $iSpe;
	  $total['amountEne'] = $iEne;
	  $total['amountHrt'] = $iHrt;
	  $total['amountTmp'] = $iTmp;
      }

      $total['time'] = totalTimeSummary($selected);
      $total['avgTime'] = fromSecondsToFull(makeSecond(
	  $total['time'])/$total['amount']);
      $total['maxTime'] = give::totalMaxTime($selected);
      $total['minTime'] = give::totalMinTime($selected);
      $total['distance'] = totalSummary($selected,"distance");

      if ( $total['amountDis'] > 0 ) {
	  $total['avgDistance'] = round($total['distance']/$total['amountDis'], 1);
      } else {
	  $total['avgDistance'] = 0;
      }
      $total['maxDistance'] = give::totalMax($selected, "distance");
      $total['minDistance'] = give::totalMin($selected, "distance");
      $total['ascent'] = totalSummary($selected,"ascent");
      $total['avgAscent'] = round($total['ascent']/$total['amount'], 1);
      $total['energy'] = totalSummary($selected,"energy");
      if ( $total['amountEne'] > 0 ) {
	  $total['avgEnergy'] = round($total['energy']/$total['amountEne'], 0);
      } else {
	  $total['avgEnergy'] = 0;
      }
      if ( $total['amountSpe'] > 0 ) {
	  $total['speedAvg'] = round(totalSummary($selected,"speedAvg")/$total['amountSpe'], 1);
      } else {
	  $total['speedAvg'] = 0;
      }
      $total['speedMax'] = give::totalMax($selected, "speedMax");
      $total['speedUnit'] = give::speedUnit($selected);
      if ( $total['amountHrt'] > 0 ) {
	  $total['hrAvg'] = round(totalSummary($selected,'hrAvg')/$total['amountHrt'], 0);
	  $total['hrMax'] = round(totalSummary($selected,'hrMax')/$total['amountHrt'], 0);
      }
      if ( $total['amountTmp'] > 0 ) {
	  $total['tempAvg'] = round(totalSummary($selected,'temperatureAvg')/
	      $total['amount'], 0);
	  $total['tempMax'] = round(totalSummary($selected,'temperatureMax')/
	      $total['amount'], 0);
      }

      return $total;
  } // END function dataMonth

  function speedUnit($workout) {
	  $w = array_pop($workout);
	  $speedUnit = $w['unitSpeed'];
	  return($speedUnit);
  } // end function speedUnit

  function monthsTotal($monthData) {
    $gr['time'] = 0;
    $gr['distance'] = 0;
    $gr['ascent'] = 0;
    $gr['energy'] = 0;
    $gr['amount'] = 0;
    $gr['speedAvg'] = 0;

    foreach ( $monthData as $month ) {
      $gr['time'] += makeSecond($month['time']);
      $gr['distance'] += $month['distance'];
      $gr['ascent'] += $month['ascent'];
      $gr['energy'] += $month['energy'];
      $gr['amount'] += $month['amount'];
      $gr['speedAvg'] += $month['speedAvg'];
    }

    $gr['time'] = fromSecondsToFull($gr['time']);
    $gr['speedAvg'] = round($gr['speedAvg']/count($monthData), 1);
    return $gr;	      
  } // end function monthsTotal


  function totalMax($workout, $type) {
	  $maxValue = 0;
	  foreach ( $workout as $w ) {
		  if ( $w[$type] > $maxValue ) {
			  $maxValue = $w[$type];
		  }
	  }
	  return($maxValue);
  } // end function totalMax

  function totalMaxTime($workout) {
	  $maxTime = 0;
	  foreach ( $workout as $w ) {
		  list($hour, $minute, $second) = split(":", $w['duration'], 3);
		  $second = substr($second, -5, 2);
		  $seconds = ($hour * 60 * 60) + ($minute * 60) + $second;
		  if ( $seconds > $maxTime ) {
			  $maxTime = $seconds;
		  }
	  }
	  return fromSecondsToFull($maxTime);
  } // end function totalMaxTime

  function totalMin($workout, $type) {
	  foreach ( $workout as $w ) {
		  if ( !isset($minValue) ) {
			  $minValue = $w[$type];
		  }
		  if ( $w[$type] < $minValue && $w[$type] != "0" ) {
			  $minValue = $w[$type];
		  }
	  }
	  return($minValue);
  } // end function totalMin

  function totalMinTime($workout) {
	  foreach ( $workout as $w ) {
		  list($hour, $minute, $second) = split(":", $w['duration'], 3);
		  $second = substr($second, -5, 2);
		  $seconds = ($hour * 60 * 60) + ($minute * 60) + $second;
		  if ( !isset($minTime) ) {
			  $minTime = $seconds;
		  }
		  if ( $seconds < $minTime ) {
			  $minTime = $seconds;
		  }
	  }
	  return fromSecondsToFull($minTime);
  } // end function totalMaxTime

} // end CLASS give

?>
