-- 
-- Databas: `polaring`
-- 

-- --------------------------------------------------------

-- 
-- Struktur för tabell `diary`
-- 

CREATE TABLE IF NOT EXISTS `diary` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `username` varchar(20) NOT NULL default '',
  `date` date NOT NULL default '0000-00-00',
  `general_hl` varchar(100) default NULL,
  `general_text` text,
  `workout_hl` varchar(100) default NULL,
  `workout_text` text,
  `food_hl` varchar(100) default NULL,
  `food_text` text,
  `vo2max` tinyint(3) unsigned default NULL,
  `hrmax` tinyint(3) unsigned default NULL,
  `hrrest` tinyint(3) unsigned default NULL,
  `hrpeak` tinyint(3) unsigned default NULL,
  `hrstand` tinyint(3) unsigned default NULL,
  `ownindex` tinyint(3) unsigned default NULL,
  `kg` tinyint(3) unsigned default NULL,
  `kg_msk` tinyint(3) unsigned default NULL,
  `pr_fat` tinyint(3) unsigned default NULL,
  `pr_h20` tinyint(3) unsigned default NULL,
  `kcal` smallint(4) unsigned default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Struktur för tabell `sampleData`
-- 

CREATE TABLE IF NOT EXISTS `sampleData` (
  `username` varchar(20) NOT NULL default '',
  `file` varchar(255) NOT NULL default '',
  `dateStartTime` bigint(20) NOT NULL default '0',
  `sampleHr` smallint(3) default NULL,
  `sampleSpeed` float default NULL,
  `sampleTime` time default NULL,
  `sampleAltitude` float default NULL,
  `sampleDistance` float default NULL,
  `sampleLocationLat` varchar(9) default NULL,
  `sampleLocationLong` varchar(9) default NULL
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Struktur för tabell `workouts`
-- 

CREATE TABLE IF NOT EXISTS `workouts` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `username` varchar(20) NOT NULL default '',
  `monitor` varchar(100) default NULL,
  `dateStartTime` bigint(20) unsigned default NULL,
  `date` mediumint(8) unsigned default NULL,
  `startTime` time default NULL,
  `duration` time default NULL,
  `hrAvg` smallint(3) unsigned default NULL,
  `hrMax` smallint(3) unsigned default NULL,
  `units` smallint(1) unsigned default NULL,
  `recordingPower` tinyint(1) unsigned default NULL,
  `recordingCadence` tinyint(1) unsigned default NULL,
  `recordingAltitude` tinyint(1) unsigned default NULL,
  `recordingSpeed` tinyint(1) unsigned default NULL,
  `recordingLocation` tinyint(1) unsigned default NULL,
  `bikeNumber` tinyint(2) unsigned default NULL,
  `unitHr` varchar(7) default NULL,
  `unitDistance` varchar(7) default NULL,
  `unitSpeed` varchar(7) default NULL,
  `unitCadence` varchar(7) default NULL,
  `unitAltitude` varchar(7) default NULL,
  `unitTemperature` varchar(7) default NULL,
  `unitPower` varchar(7) default NULL,
  `unitEnergy` varchar(7) default NULL,
  `energy` mediumint(4) unsigned default NULL,
  `energyTotal` mediumint(8) unsigned default NULL,
  `distance` float unsigned default NULL,
  `speedAvg` float unsigned default NULL,
  `speedMax` float unsigned default NULL,
  `temperatureMin` smallint(3) default NULL,
  `temperatureAvg` smallint(3) default NULL,
  `temperatureMax` smallint(3) default NULL,
  `altitudeMin` mediumint(5) default NULL,
  `altitudeAvg` mediumint(5) default NULL,
  `altitudeMax` mediumint(5) default NULL,
  `ascent` mediumint(5) default NULL,
  `file` varchar(255) default NULL,
  `md5sum` varchar(33) default NULL,
  `numberOfSamples` mediumint(5) default NULL,
  `duplicate` tinyint(1) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
