<?php

/*

Name:		srdParser.php
Edited:		27/11/2004
Description:	Reads and parses a workout file (srd)

*/

function getSrdForMonthTableView($file) {
	
	/* read file */
	
	$fContents = openSrdFile($file);

	/* type of monitor */

	getTypeOfMonitor($workout,$fContents);
	
	/* date of workout */

	getDateOfWorkout($workout,$fContents);
					
	/* workout duration */

	getWorkoutDuration($workout,$fContents);

	/* heartrate */
	
	getHr($workout,$fContents);
	
	/* units */

	getUnits($workout,$fContents);

	getRecordings($workout,$fContents);
	
	/* units full */

	specifyUnits($workout,$fContents);

	/* energy */

	getEnergy($workout,$fContents);
	
	/* distance */

	getDistance($workout,$fContents);

	/* speed */

	getSpeed($workout,$fContents);
	
	/* temperature */

	getTemperature($workout,$fContents);
	
	/* altitude */

	getAltitude($workout,$fContents);
	
	return $workout;
	
}

function getSrdComplete($file) {
	
	/* read file */
	
	$fContents = openSrdFile($file);

	/* bytes in file */

	getBytesInFile($workout,$fContents);

	/* number of laps */

	getNumberOfLaps($workout,$fContents);
		
	/* User Id */

	getUserId($workout,$fContents);

	/* type of monitor */

	getTypeOfMonitor($workout,$fContents);
	
	/* date of workout */

	getDateOfWorkout($workout,$fContents);
					
	/* workout duration */

	getWorkoutDuration($workout,$fContents);

	/* heartrate */
	
	getHr($workout,$fContents);
	
	/* units */

	getUnits($workout,$fContents);

	getRecordings($workout,$fContents);
	
	/* units full */

	specifyUnits($workout,$fContents);

	/* exercise label */

	getExerciseLabel($workout,$fContents);
	
	/* distance */

	getDistance($workout,$fContents);

	/* speed */

	getSpeed($workout,$fContents);

	/* interval */

	getInterval($workout,$fContents);

	/* HR limits */

	getHrLimits($workout,$fContents);
	
	 /* Best lap */

	getBestLap($workout,$fContents);
	
	/* energy, total energy (if OwnCal enabled) */

	getEnergy($workout,$fContents);
	
	/* cumulative counters */

	getCumulativeCounters($workout,$fContents);

	/* distance */

	getDistance($workout,$fContents);

	/* speed */

	getSpeed($workout,$fContents);
		
	/* avg, max cadence */

	getCadence($workout,$fContents);
	
	/* temperature */

	getTemperature($workout,$fContents);

	/* altitude */

	getAltitude($workout,$fContents);

	/* avg, max power data */
	
	getPower($workout,$fContents);
	
	/* lap data */
	
	getLapData($workout,$fContents);
	
	/* sample data */

	getSampleData($workout,$fContents);

	return $workout;
}

function openSrdFile($file) {
	if (file_exists($file)) {
		$fp = fopen($file, 'rb');
		$i = 0;
		while (!feof ($fp)) {
  			$fContents[$i] = fread($fp, 1);
			$i++;
		}
		fclose ($fp);
	} else {
		dieError("Impossible to open file");
	}

	return $fContents;	
}

function getBytesInFile(&$workout,$fContents) {

	$workout['bytesInFile'] = HTD(BTH($fContents[0])) + (HTD(BTH($fContents[1]))<< 8);

}

function getExerciseLabel(&$workout,$fContents) {
	
	$workout['exerciseNumber'] = HTD(BTH($fContents[2]));
	if (($exercise['number'] > 0) && ($exercise['number'] <= 5 )) {
		for ($i = 0; $i < 7; $i++) {
			$workout['exerciseLabel'] = $workout['exerciseLabel']."".decodeChar(HTD(BTH($fContents[$i + 3])));
		}
  	} else {
    		$workout['exerciseLabel'] = "Empty";
	}

}



function getTypeOfMonitor(&$workout,$fContents) {
	
	if ((HTD(BTH($fContents[34])) == 0) && (HTD(BTH($fContents[36])) == 251)) {
		$workout['monitor'] = 11;	
	} else {
		$workout['monitor'] = 12;
	}

}

function getDateOfWorkout(&$workout,$fContents) {
	
	/* date of workout */
	
	$dTmSeconds = BTH($fContents[10]);
	$dTmMinutes = BTH($fContents[11]);
	$dTmHours = BTH($fContents[12]) & 0x7f;

	/* AM/PM mode detection */

	if ((HTD(BTH($fContents[12])) & 0x80) == 0x80) {
		$dTmHours += 12;
	}

	$dDay = BTH($fContents[13]);
	$dYear = 100 + BTH($fContents[14]);
	$dMonth = HTD(BTH($fContents[15])) & 0x0f;
	$workout['dateStartTime'] = mktime($dTmHours, $dTmMinutes, $dTmSeconds, $dMonth, $dDay, $dYear);

}

function getWorkoutDuration(&$workout,$fContents) {
	
	/* workout duration */

	$durSeconds = BTH($fContents[16]);
	$durMinutes = BTH($fContents[17]);
	$durHours = BTH($fContents[18]);
	$workout['duration'] = fullTime($durHours, $durMinutes, $durSeconds);

}

function getHr(&$workout,$fContents) {

	$workout['hrAvg'] = HTD(BTH($fContents[19]));
	$workout['hrMax'] = HTD(BTH($fContents[20]));

}

function getNumberOfLaps(&$workout,$fContents) {

	$workout['numberOfLaps'] = BTH($fContents[21]);
	
}

function getUserId(&$workout,$fContents) {

	$workout['userId'] = BTH($fContents[24]);

}

function getUnits(&$workout,$fContents) {

	/* Units 0 = Euro(Metric) Units 1 = Us(English) Units */
	
	if (HTD(BTH($fContents[25])) & 0x02 == 0) {  
		$workout['units'] = 1;
	} else {
		$workout['units'] = 0;
	}

}

function getRecordings(&$workout,$fContents) {
	
	if ($workout['monitor'] > 11) {
		$bike2 = (HTD(BTH($fContents[26])) & 32) == 0x20;
		$bike1 = (HTD(BTH($fContents[26])) & 16) == 0x10;
		$workout['recordingPower'] = (HTD(BTH($fContents[26])) & 8) == 0x08;
		$workout['recordingCadence'] = (HTD(BTH($fContents[26])) & 4) == 0x04;
		$workout['recordingAltitude'] = (HTD(BTH($fContents[26])) & 2) == 0x02;
	} else {
		$workout['recordingPower'] = 0;
		$workout['recordingCadence'] = 0;
		$workout['recordingAltitude'] = 0;
	}
	
	if (($bike1 == 0) && ($bike2 == 0)) {
		$workout['recordingSpeed'] = 0;
		$workout['bikeNumber'] = 0;
	} else {
		$workout['recordingSpeed'] = 1;
		if ($bike1 == 1) {
			$workout['bikeNumber'] = 1;
		} else {
			$workout['bikeNumber'] = 2;
		}
	}

}

function getInterval(&$workout,$fContents) {
	
	switch (HTD(BTH($fContents[27]))) {
		case 0: $workout['interval'] = 5;  
			break;
		case 1: $workout['interval'] = 15; 
			break;
		case 2: $workout['interval'] = 60; 
			break;
		default: $workout['interval'] = 0;  
			break;
	}

}

function getHrLimits(&$workout,$fContents) {
	
	$workout['hrLimitLower'][0] = HTD(BTH($fContents[29]));
	$workout['hrLimitUpper'][0] = HTD(BTH($fContents[30]));
	$workout['hrLimitLower'][1] = HTD(BTH($fContents[31]));
	$workout['hrLimitUpper'][1] = HTD(BTH($fContents[32]));
	$workout['hrLimitlower'][2] = HTD(BTH($fContents[33]));
	$workout['hrLimitUpper'][2] = HTD(BTH($fContents[34]));
		
	/* time below, within, above hr limits 1 */
	
	$bZ1S = BTH($fContents[38]);
	$bZ1M = BTH($fContents[39]);
	$bZ1H = BTH($fContents[40]);
	$wZ1S = BTH($fContents[41]);
	$wZ1M = BTH($fContents[42]);
	$wZ1H = BTH($fContents[43]);
	$aZ1S = BTH($fContents[44]);
	$aZ1M = BTH($fContents[45]);
	$aZ1H = BTH($fContents[46]);
	$workout['hrLimitTimeAboveMax'][0] = fullTime($aZ1H,$aZ1M,$aZ1S);
	$workout['hrLimitTimeWithin'][0] = fullTime($wZ1H,$wZ1M,$wZ1S);
	$workout['hrLimitTimeBelow'][0] = fullTime($bZ1H,$bZ1M,$bZ1S);
	
	/* time below, within, above hr limits 2 */
	
	$bZ2S = BTH($fContents[47]);
	$bZ2M = BTH($fContents[48]);
	$bZ2H = BTH($fContents[49]);
	$wZ2S = BTH($fContents[50]);
	$wZ2M = BTH($fContents[51]);
	$wZ2H = BTH($fContents[52]);
	$aZ2S = BTH($fContents[53]);
	$aZ2M = BTH($fContents[54]);
	$aZ2H = BTH($fContents[55]);
	$workout['hrLimitTimeAboveMax'][1] = fullTime($aZ2H,$aZ2M,$aZ2S);
	$workout['hrLimitTimeWithin'][1] = fullTime($wZ2H,$wZ2M,$wZ2S);
	$workout['hrLimitTimeBelow'][1] = fullTime($bZ2H,$bZ2M,$bZ2S);
		
	$bZ3S = BTH($fContents[56]);
	$bZ3M = BTH($fContents[57]);
	$bZ3H = BTH($fContents[58]);
	$wZ3S = BTH($fContents[59]);
	$wZ3M = BTH($fContents[60]);
	$wZ3H = BTH($fContents[61]);
	$aZ3S = BTH($fContents[62]);
	$aZ3M = BTH($fContents[63]);
	$aZ3H = BTH($fContents[64]);
	$workout['hrLimitTimeAboveMax'][2] = fullTime($aZ3H,$aZ3M,$aZ3S);
	$workout['hrLimitTimeWithin'][2] = fullTime($wZ3H,$wZ3M,$wZ3S);
	$workout['hrLimitTimeBelow'][2] = fullTime($bZ3H,$bZ3M,$bZ3S);

}

function getBestLap(&$workout,$fContents) {

	$bLapSeconds = BTH($fContents[67]);
	$bLapMinutes = BTH($fContents[68]);
	$bLapHours = BTH($fContents[69]);
	$workout['bestLap'] = fullTime($bLapHours,$bLapMinutes,$bLapSeconds);

}

function getEnergy(&$workout,$fContents) {
	
	/* energy*/

	$energyL2 = BTH($fContents[70]);
	$energyM2 = BTH($fContents[71]);
	$energyH2 = BTH($fContents[72]);
	$workout['energy'] = ($energyL2/10) + ($energyM2 * 10) + ($energyH2 * 1000);

	$energyTotalL2 = BTH($fContents[73]);
	$energyTotalM2 = BTH($fContents[74]);
	$energyTotalH2 = BTH($fContents[75]);
	$workout['energyTotal'] = $energyTotalL2 + ($energyTotalM2 * 100) + ($energyTotalH2 * 10000);

}

function getCumulativeCounters(&$workout,$fContents) {

	$cWorkoutTimeHours = BTH($fContents[76]);
	$cWorkoutTimeHHours = BTH($fContents[77]);
	$cWorkoutTimeMinutes = BTH($fContents[78]);
	$workout['workoutTimeTotal'] = fullTime($cWorkoutTimeHHours, $cWorkoutTimeHours, $cWorkoutTimeMinutes);
	
	if ($workout['monitor'] > 11) {
		$cRidingTimeHours = BTH($fContents[79]);
		$cRidingTimeHHours = BTH($fContents[80]);
		$cRidingTimeMinutes = BTH($fContents[81]);
		$workout['ridingTimeTotal'] = fullTime($cRidingTimeHHours, $cRidingTimeHours, $cRidingTimeMinutes);

		$odometerL2 = BTH($fContents[82]);
		$odometerM2 = BTH($fContents[83]);
		$odometerH2 = BTH($fContents[84]);
		$workout['odometer'] = $odometerL2 + ($odometerM2 * 100) + ($odometerH2 * 10000);
	}

}

function getDistance(&$workout,$fContents) {

	if ($workout['recordingSpeed'] == 1) {
		$exerciseDistance1 = HTD(BTH($fContents[85]));
		$exerciseDistance2 = HTD(BTH($fContents[86]));
		$workout['distance'] = ($exerciseDistance1 + ($exerciseDistance2 << 8)) / 10.0;
	} else {
		$workout['distance'] = 0;
	}
	
}

function getSpeed(&$workout,$fContents) {

	if ($workout['recordingSpeed'] == 1) {
		$speedAvg1 = HTD(BTH($fContents[87]));
		$speedAvg2 = HTD(BTH($fContents[88])) & 15;
		$workout['speedAvg'] = round((($speedAvg2 << 8) | $speedAvg1) / 16,2);
		$speedMax1 = HTD(BTH($fContents[88]));
		$speedMax2 = HTD(BTH($fContents[89]));
		$workout['speedMax'] = round((($speedMax2 << 4) | $speedMax1 >> 4) / 16,2);
	} else {
		$workout['speedAvg'] = 0;
		$workout['speedMax'] = 0;
	}

}

function getCadence(&$workout,$fContents) {

	if ($workout['recordingCadence'] == 1) {
		$workout['cadenceAvg'] = HTD(BTH($fContents[90]));
		$workout['cadenceMax'] = HTD(BTH($fContents[91]));
	} else {
		$workout['cadenceAvg'] = 0;
		$workout['cadenceMax'] = 0;
	}

}

function getTemperature(&$workout,$fContents) {

	if ($workout['recordingAltitude'] == 1) {
		if ($workout['units'] == 1) {
			$workout['temperatureMin'] = HTD(BTH($fContents[98]));
			$workout['temperatureAvg'] = HTD(BTH($fContents[99]));
			$workout['temperatureMax'] = HTD(BTH($fContents[100]));
		} else {
			$workout['temperatureMin'] = decodeTemperature(HTD(BTH($fContents[98])));
			$workout['temperatureAvg'] = decodeTemperature(HTD(BTH($fContents[99])));
			$workout['temperatureMax'] = decodeTemperature(HTD(BTH($fContents[100])));
		}
	}

}

function getAltitude(&$workout,$fContents) {

	if ($workout['recordingAltitude'] == 1) {
		$workout['altitudeMin'] = decodeAltitude(HTD(BTH($fContents[92])),HTD(BTH($fContents[93])));
		$workout['altitudeAvg'] = decodeAltitude(HTD(BTH($fContents[94])),HTD(BTH($fContents[95])));
		$workout['altitudeMax'] = decodeAltitude(HTD(BTH($fContents[96])),HTD(BTH($fContents[97])));
		$workout['ascent'] = HTD(BTH($fContents[101])) + (HTD(BTH($fContents[102])) << 8);
	}
	
}

function getPower(&$workout,$fContents) {
	
	if ($workout['recordingPower'] == 1) {
		$workout['powerAvg'] = HTD(BTH($fContents[103])) + (LNIB(HTD(BTH($fContents[104]))) << 4);
		$workout['powerMax'] = UNIB(HTD(BTH($fContents[104]))) + (HTD(BTH($fContents[105])) << 4);
		$workout['powerPiAvg'] = HTD(BTH($fContents[106])) >> 1;
		$workout['powerPiMax'] = HTD(BTH($fContents[107])) >> 1;
		$workout['powerLrbAvg'] = HTD(BTH($fContents[108])) >> 1;
  		/* there is no max_power LR balance */
		$workout['powerLrbMax'] = 0;
	}

}

function getLapData(&$workout,$fContents) {

	$workout['lapSize'] = 6;
	
	if ($workout['recordingAltitude'] == 1) {
		$workout['lapSize'] += 5;
	}
	
   	if ($workout['recordingSpeed'] == 1) {
		if ($workout['recordingCadence'] == 1) {
			$workout['lapSize'] += 1;
		}
      		if ($workout['recordingPower'] == 1) {
			$workout['lapSize'] += 4;
		}
		$workout['lapSize'] += 4;
	}
	
	if ($workout['monitor'] == 11) {
		$workout['indexLapsStart'] = 78;
	} else {
		$workout['indexLapsStart'] = 109;
	} 
	
	for ($i = 0; $i < $workout['numberOfLaps']; $i++) {
                $lO = $workout['indexLapsStart'] + ($i * $workout['lapSize']);
		
		/* timestamp (split) */
		
		$bLapEndHour = HTD(BTH($fContents[$lO + 2]));
                $bLapEndMinute = HTD(BTH($fContents[$lO + 1] & 0x3f));
               	$bLapEndSecond = HTD(BTH($fContents[$lO] & 0x3f));
                $workout['lapTimeSplit'][$i] = ($bLapEndSecond * 10) + ($bLapEndMinute * 60 * 10) + ($bLapEndHour * 60 * 60 * 10);

		 /* heart rate data */
		
		$workout['lapHrSplit'][$i] = HTD(BTH($fContents[$lO + 3]));
		$workout['lapHrAvg'][$i] = HTD(BTH($fContents[$lO + 4]));
		$workout['lapHrMax'][$i] = HTD(BTH($fContents[$lO + 5]));
		$lO += 6;

		/* altitude data */

		if ($workout['recordingAltitude'] == 1) {
			$lapEndAlt = HTD(BTH($fContents[$lO])) + (HTD(BTH(($fContents[$lO + 1])) << 8) - 512);
			$workout['lapAltitude'][$i] = $lapEndAlt;
			$workout['lapAscent'][$i] = HTD(BTH(($fContents[$lO + 2])) + HTD(BTH(($fContents[$lO + 3])) << 8));
			if ($workout['units'] == 0) {
				// metric units: offset from -10 C
				$workout['lapTemperature'][$i] = (HTD(BTH($fContents[$lO + 4])) - 10);
			} else {
				// english units: offset from 14 F
				$workout['lapTemperature'][$i] = (HTD(BTH($fContents[$lO + 4])) + 14);
			}
			$lO += 5;
                }

		/* speed data */

		if ($workout['recordingSpeed'] == 1) {
			
			/* cadence data */
			
			if ($workout['recordingCadence'] == 1) {
				$workout['lapCadence'][$i] = HTD(BTH($fContents[$lO]));
				$lO += 1;
			}
                    
			/* next 4 bytes are power data */

			if ($workout['recordingPower'] == 1) {
				$workout['lapPower'][$i] = (HTD(BTH($fContents[$lO+1])) << 8);
				$workout['lapPowerLRB'][$i] = (HTD(BTH($fContents[$lO+3])) >> 1);
				$workout['lapPowerPI'][$i] = (HTD(BTH($fContents[$lO+2])) >> 1);
				$lO += 4;
			}
			$lapDistance[$i] = HTD(BTH($fContents[$lO])) + (HTD(BTH($fContents[$lO + 1])) << 8);
			$lapEndSpeed = (HTD(BTH($fContents[$lO + 2])) + (HTD(BTH($fContents[$lO + 3])) & 0xf0) << 4) / 16;
			$lO += 4;
		}
	}
}

function getSampleData(&$workout,$fContents) {

	/* sample size */

	$offset = $workout['indexLapsStart'] + ($workout['numberOfLaps'] * $workout['lapSize']);
	$sampleSize = 1;
	
	if ($workout['recordingAltitude'] == 1) {
		$sampleSize += 2;
	}
     	
	if ($workout['recordingSpeed'] == true) {
      		if ($workout['recordingAltitude'] == 1) { 
			$sampleSize -= 1;
		}
        	if ($workout['recordingCadence'] == 1) {
			$sampleSize += 1;
		}
        	if ($workout['recordingPower'] == 1) { 
			$sampleSize += 4;
		}
		$sampleSize += 2;
	}
	
	/* number of samples */

	$workout['numberOfSamples'] = round(($workout['bytesInFile'] - $offset) / $sampleSize);
		
	/* actual sample data - it's in reverse order! */

	for ($x = 0; $x < $workout['numberOfSamples']; $x++) {
		$i = $workout['numberOfSamples'] - 1 - $x;
		$workout['sampleHr'][$i] = HTD(BTH($fContents[$offset]));
		$offset++;

		if ($workout['recordingAltitude'] == 1) {
			$workout['sampleAltitude'][$i] = (HTD(BTH($fContents[$offset])) + ((HTD(BTH($fContents[$offset + 1])) & 0x1f) << 8) - 512);
			$offset += 2;
		}
	     	
		if ($workout['recordingSpeed'] == 1) {
			if ($workout['recordingAltitude'] == 1) {
				$offset -= 1;
			}
			$workout['sampleSpeed'][$i] = (((HTD(BTH($fContents[$offset])) & 224) << 3) + HTD(BTH($fContents[$offset + 1])))/16;
			$workout['sampleSpeed'][$i] = round($workout['sampleSpeed'][$i],2);
			$offset += 2;

			if ($workout['recordingPower'] == true) {
				$workout['samplePower'][$i] = HTD(BTH($fContents[$offset])) + (HTD(BTH($fContents[$offset]))<< 8);
				$workout['samplePowerLRB'][$i] = HTD(BTH($fContents[$offset+2])) >> 1;
				$workout['samplePowerPI'][$i] = HTD(BTH($fContents[$offset+3])) >> 1;
				$offset += 4;
			}

			if ($workout['recordingCadence'] == true) {
				$workout['sampleCadence'][$i] = HTD(BTH($fContents[$offset]));
				$offset++;
			}
		}

	}

}

?>
