<?php 
/**
* @version 00.04.03
* @package polaring
* @license This component in released under the GNU/GPL License
*
* File: functions/strings.php
* Role: Parses translations -- e.g. files in /translations
* NOTE: All functions are to be `returning' strings.
*
**/

class strings {

  function expression($section, $string) {
	  $file = $_SESSION['translationFile'];
	  $tobeEchoed = strings::getString($file, $section, $string);
	  $echo = strings::emptyCheck($section, $string, $tobeEchoed);

	  return($echo);
  }


  function emptyCheck($section, $string, $tobeEchoed) {
	  /**********************************************************\
	   * If the string that is to be echoed is empty (or, rather,
	   * equal to ""), then use the default translation-file,
	   * english.xml.
	  \**********************************************************/
	  $defaultTranslation = $_SESSION['dirMain'].
		  "/translations/english.xml";
	  if ( trim($tobeEchoed) != "" ) {
		  $echo = $tobeEchoed;
	  } else {
		  $echo = strings::getString($defaultTranslation,
			  $section, $string);
		  if ( trim($echo) == "" ) {
			  $echo = "\n<p><b>".strings::expression("error",
				  "Error")."!</b><br />".
				  strings::expression("error", 
				  "Expression")." '".$string."' ".
				  strings::expression("error", "inSection").
				  " '".$section."' ".
				  strings::expression("error", "notFound").
				  ".<br />".
				  strings::expression("error", "notInDefTr").
				  "</p>\n";
		  }
	  }

	  return($echo);
  }


  function translationInfo($file) {
    $fileParts = explode("/", $file);
    $max = count($fileParts);

    $info['filename'] = $fileParts[($max - 1)];
    $info['language'] = strings::getString($file, "translation", "language");
    $info['version'] = strings::getString($file, "translation", "version");
    $info['author_name'] = strings::getString($file, "author", "name");
    $info['author_email'] = strings::getString($file, "author", "email");

    return $info;
  } // end function translationInfo
    

  function openFile($file) {
    if ( file_exists($file) ) {
      $fContents = file($file);
    } else {
	    //File not found
      die("<p>Thought the file ".$file." would be there, but it wasn't?</p>");
    }
    return $fContents;
  } // end function openFile


  function getString($file, $block, $string) {
    $fileContents = strings::openFile($file);
    $blockContents = strings::getBlock($fileContents, $block);
    $stringContents = strings::getBlock($blockContents, $string);
    $stringValue = strings::getValue($stringContents, $string);
      
    return($stringValue);
  } // end function getSTring


  function getValue($stringContents, $string) {
    $max = count($stringContents);
    if ( $max == 1 ) {
	$stringValue = substr($stringContents['0'], 
	    (strlen($string)+2), -(strlen($string)+3));
    } else {
	if ( isset($stringContents) ) {
	    foreach ( $stringContents as $content ) {
		$value .= $content;
	    }
	}
	$stringValue = substr($value, (strlen(
	    $string)+2), -(strlen($string)+3));
    }
    return $stringValue;
  } // end function getValue


  function getBlock($fContents, $block) {
    $block_start = "<".$block.">";
    $block_stop = "</".$block.">";
    $block_read = false;

    for ( $i = 0; $i < sizeof($fContents); $i++ ) {
      // First line of the block?
      if ( ($block_read == false ) && 
	   (substr(trim($fContents[$i]), 0, strlen($block_start)) 
	    == $block_start) ) {
	$block_read = true;
	//continue;
      }
      if ( $block_read == true ) {
	$lines[] = trim($fContents[$i]);
	//continue
      }
      // Last line of block? If so, exit
      if ( ($block_read == true) &&
	   (substr($fContents[$i], -strlen($block_stop))) == $block_stop ) {
	break;
      }
      if ( ($block_read == true) && 
	   (substr(trim($fContents[$i]), 0, 
		   strlen($block_stop)) == $block_stop) ) {
	break;
      }
    }
    return $lines;    
  } // end function getBlock
    

  function giveTranslationfiles() {
    $files = array();
    $stack[] = $_SESSION['dirMain']."/translations";

    while ( $stack ) {
      $current_dir = array_pop($stack);
      if ( $dh = opendir($current_dir) ) {
	while ( ($file = readdir($dh)) !== false ) {
	  if ( $file !== '.' AND $file !== '..' ) {
	    $current_file = $current_dir."/".$file;
	    if ( is_file($current_file) ) {
	      if ( substr(strtolower($file), -3 ) == "xml" ) {
		$files[] = $current_file;
	      }
	    } elseif ( is_dir($current_file) ) {
	      $stack[] = $current_file;
	    }
	  }
	}
      }
    }
    return $files;
  } // end function giveTranslationfiles

} // end class

?>
