<?php 

class xml {

	function load_essentials() {
		require_once($_SESSION['dirMain'].'/functions/XML.php');
		require_once($_SESSION['dirMain'].'/functions/Unicode.php');
		return;
	} // end function load_essentials

	function parseFile($file) {
		xml::load_essentials();
		$data = fileFunctions::fileToString($file);
		$xmlarray = read_xml_array_from_text($data);

		return($xmlarray);
	} // end function parseFile

	function getBlocks($block, $data) {
	    $blockStart = "<".$block.">";
	    $blockEnd = "</".$block.">";
	    $blocksWEnd = split($blockStart, $data);

	    $retBlocks = array();

	    foreach ( $blocksWEnd as $blocks ) {
		if ( strstr($blocks, $blockEnd) ) {
		    $endPos = strpos($blocks, $blockEnd);
		    $retBlocks[] = trim(substr($blocks, 0, $endPos));
		}
	    }

	    return($retBlocks);
	} // end function getBlocks


} // end class xml


class XmlElement {
  var $name;
  var $attributes;
  var $content;
  var $children;
};

function xml_to_object($xml) {
  $parser = xml_parser_create();
  xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
  xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
  xml_parse_into_struct($parser, $xml, $tags);
  xml_parser_free($parser);

  $elements = array();  // the currently filling [child] XmlElement array
  $stack = array();
  foreach ($tags as $tag) {
   $index = count($elements);
   if ($tag['type'] == "complete" || $tag['type'] == "open") {
     $elements[$index] = new XmlElement;
     $elements[$index]->name = $tag['tag'];
     $elements[$index]->attributes = $tag['attributes'];
     $elements[$index]->content = $tag['value'];
     if ($tag['type'] == "open") {  // push
       $elements[$index]->children = array();
       $stack[count($stack)] = &$elements;
       $elements = &$elements[$index]->children;
     }
   }
   if ($tag['type'] == "close") {  // pop
     $elements = &$stack[count($stack) - 1];
     unset($stack[count($stack) - 1]);
   }
  }
  return $elements[0];  // the single top-level element
}



function GetXMLTree ($xmldata) 
{ 
    // we want to know if an error occurs 
    ini_set ('track_errors', '1'); 

    $xmlreaderror = false; 

    $parser = xml_parser_create ('ISO-8859-1'); 
    xml_parser_set_option ($parser, XML_OPTION_SKIP_WHITE, 1); 
    xml_parser_set_option ($parser, XML_OPTION_CASE_FOLDING, 0); 
    if (!xml_parse_into_struct ($parser, $xmldata, $vals, $index)) { 
        $xmlreaderror = true; 
        //echo "error"; 
    } 
    xml_parser_free ($parser); 

    if (!$xmlreaderror) { 
        $result = array (); 
        $i = 0; 
	if (isset ($vals[$i]['attributes'])) {
	    //print_r(array_keys($vals[$i]['attributes']));
	    foreach ( array_keys($vals[$i]['attributes']) as $attkey) {
		$attributes[$attkey] = $vals[$i]['attributes'][$attkey];
		//echo "TEST: $attkey";
	    }
	}

	$result[$vals[$i]['tag']] = array_merge ($attributes, GetChildren ($vals, $i, 'open')); 

    } 

    ini_set ('track_errors', '0'); 
    return $result; 
} 

function GetChildren ($vals, &$i, $type) 
{ 
    if ($type == 'complete') { 
        if (isset ($vals [$i]['value'])) 
            return ($vals [$i]['value']); 
        else 
            return ''; 
    } 

    $children = array (); // Contains node data 

    /* Loop through children */ 
    while ($vals [++$i]['type'] != 'close') { 
        $type = $vals [$i]['type']; 
        // first check if we already have one and need to create an array 
        if (isset ($children [$vals [$i]['tag']])) { 
            if (is_array ($children [$vals [$i]['tag']])) { 
                $temp = array_keys ($children [$vals [$i]['tag']]); 
                // there is one of these things already and it is itself an array 
                if (is_string ($temp [0])) { 
                    $a = $children [$vals [$i]['tag']]; 
                    unset ($children [$vals [$i]['tag']]); 
                    $children [$vals [$i]['tag']][0] = $a; 
                } 
            } else { 
                $a = $children [$vals [$i]['tag']]; 
                unset ($children [$vals [$i]['tag']]); 
                $children [$vals [$i]['tag']][0] = $a; 
            } 

            $children [$vals [$i]['tag']][] = GetChildren ($vals, $i, $type); 
        } else 
            $children [$vals [$i]['tag']] = GetChildren ($vals, $i, $type); 
        // I don't think I need attributes but this is how I would do them: 
        if (isset ($vals [$i]['attributes'])) { 
            $attributes = array (); 
            foreach (array_keys ($vals [$i]['attributes']) as $attkey) 
            $attributes [$attkey] = $vals [$i]['attributes'][$attkey]; 
            // now check: do we already have an array or a value? 
            if (isset ($children [$vals [$i]['tag']])) { 
                // case where there is an attribute but no value, a complete with an attribute in other words 
                if ($children [$vals [$i]['tag']] == '') { 
                    unset ($children [$vals [$i]['tag']]); 
                    $children [$vals [$i]['tag']] = $attributes; 
                } 
                // case where there is an array of identical items with attributes 
                elseif (is_array ($children [$vals [$i]['tag']])) { 
                    $index = count ($children [$vals [$i]['tag']]) - 1; 
                    // probably also have to check here whether the individual item is also an array or not or what... all a bit messy 
                    if ($children [$vals [$i]['tag']][$index] == '') { 
                        unset ($children [$vals [$i]['tag']][$index]); 
                        $children [$vals [$i]['tag']][$index] = $attributes; 
                    } 
                    $children [$vals [$i]['tag']][$index] = array_merge ($children [$vals [$i]['tag']][$index], $attributes); 
                } else { 
                    $value = $children [$vals [$i]['tag']]; 
                    unset ($children [$vals [$i]['tag']]); 
                    $children [$vals [$i]['tag']]['value'] = $value; 
                    $children [$vals [$i]['tag']] = array_merge ($children [$vals [$i]['tag']], $attributes); 
                } 
            } else 
                $children [$vals [$i]['tag']] = $attributes; 
        } 
    } 

    return $children; 
} 


?>
