<?php
/**
* @version 00.04.03
* @package polaring
* @license This component in released under the GNU/GPL License
*
* Fil: images/graph.php
* Roll: Innehåller funktioner för varje graf.
*
**/


function dayHeartrate($dateTime) {
    $workout = fileFunctions::selectFullWorkout($dateTime);

    for ( $i = 0; $i < $workout["numberOfSamples"]; $i++) {
	$datay[] = $workout["sampleHr"][$i];
	$datax[] = makeSecond($workout['sampleTime'][$i]) / 60;
    }

    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_line.php';

    $g = new Graph(660,300,"auto");

    $g->title->Set(strings::expression("polar", "hr"));

    $g->SetMargin(40,40,40,40);
    $g->SetTickDensity(TICKD_SPARSE);
    $g->SetFrame(true,'red',0);
    $g->SetMarginColor('white');
    $g->legend->Pos(0.03, 0.25, "right", "center");
    $g->img->SetAntiAliasing(true);

    $g->SetScale("intlin");

    $lplot = new LinePlot($datay,$datax);
    $lplot->SetColor('red');
    $g->yaxis->HideTicks(true,false);
    $g->yaxis->scale->SetGrace(5, 0);
    $g->xaxis->HideTicks(true,false);
    $g->yaxis->title->Set(strings::expression("polar", "hr"));
    $g->xaxis->title->Set(strings::expression("polar", "minutes"));
    $g->Add($lplot);

    if ( $_SESSION['tty']['enabled'] ) {
	DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	$g->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	$g->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$g->xaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$g->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$g->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$lplot->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
    }

    $g->Stroke();
} // end function dayHeartrate


function dayHeartrateSpeed($dateTime) {
    $workout = fileFunctions::selectFullWorkout($dateTime);

    for ( $i = 0; $i < count($workout['sampleDistance']); $i++ ) {
	$datax[] = $workout['sampleDistance'][$i];
	if ( $workout['sampleSpeed'][$i] ) {
	    $datay2[] = $workout['sampleSpeed'][$i];
	} else {
	    $datay2[] = "";
	}
	if ( $workout['sampleHr'][$i] ) {
	    $datay[] = $workout['sampleHr'][$i];
	} else {
	    $datay[] = "";
	}
    }

    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_line.php';

    $g = new Graph(660,300,"auto");

    $g->title->Set(strings::expression("polar", "hr_and_speed"));

    $g->SetMargin(40,40,40,40);
    $g->SetTickDensity(TICKD_SPARSE);
    $g->SetFrame(true,'red',0);
    $g->SetMarginColor('white');
    $g->legend->Pos(0.03, 0.25, "right", "center");
    $g->img->SetAntiAliasing(true);

    $g->SetScale("intlin");
    $lplot = new LinePlot($datay,$datax);
    $lplot->SetColor('red');
    $g->yaxis->HideTicks(true,false);
    $g->yaxis->scale->SetGrace(5, 0);
    $g->xaxis->HideTicks(true,false);
    $g->yaxis->title->Set(strings::expression("polar", "hr"));
    $g->xaxis->title->Set(strings::expression("polar", "distance"));
    $g->Add($lplot);

    $lplot2= new LinePlot($datay2,$datax);
    $lplot2->SetColor('blue');
    $g->SetY2Scale("lin");
    $g->y2axis->HideTicks(true,false);
    $g->y2axis->scale->SetGrace(60, 0);
    $g->y2axis->title->Set(strings::expression("polar", "speed"));
    $g->AddY2($lplot2);

    if ( $_SESSION['tty']['enabled'] ) {
	DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	$g->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	$g->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$g->y2axis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$g->xaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$g->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$g->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$lplot->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
    }

    $g->Stroke();
} // end function dayHeartrateSpeed


function dayHeartratePies($dateTime) {
    $workout = fileFunctions::selectFullWorkout($dateTime);

    //if ( !isset($workout['personalMaxHr']) ) {
    $maxHR = $_SESSION['maxHr']; 
    /*} else { 
	$maxHR = $workout['personalMaxHr'];
    } */

    for ($i = 0; $i < $workout["numberOfSamples"]; $i++) {
	$hr = $workout["sampleHr"][$i];
	$hr1 = round($hr, -1);

	$hrr = "ca $hr1";

	$hr2[$hrr]['amount'] = (int) $hr2[$hrr]['amount'] +1;

	if ( $hr >= 0 && $hr <= ( 0.49 * $maxHR ) ) {
	    $pz = strings::expression("polar", "hrZone").
		"#0 (0-49)";
	} elseif ( $hr >= ( 0.50 * $maxHR ) && 
	    $hr <= ( 0.59 * $maxHR ) ) {
		$pz = strings::expression("polar", "hrZone").
		    " #1 (50-59%%)";
	} elseif ( $hr >= ( 0.60 * $maxHR ) && 
	    $hr <= ( 0.69 * $maxHR ) ) {
		$pz = strings::expression("polar", "hrZone").
		    " #2 (60-69%%)";
	} elseif ( $hr >= ( 0.70 * $maxHR ) &&
	    $hr <= ( 0.79 * $maxHR ) ) {
		$pz = strings::expression("polar", "hrZone").
		    " #3 (70-79%%)";
	} elseif ( $hr >= ( 0.80 * $maxHR ) && 
	    $hr <= ( 0.89 * $maxHR ) ) {
		$pz = strings::expression("polar", "hrZone").
		    " #4 (60-69%%)";
	} elseif ( $hr >= ( 0.90 * $maxHR ) ) {
	    $pz = strings::expression("polar", "hrZone").
		" #5 (80-99%%)";
	}
	$puzo[$pz]['amount'] = (int) $puzo[$pz]['amount'] + 1;
    }

    foreach (array_keys($hr2) as $a) {
	foreach (array_keys($hr2[$a]) as $b) {
	    $data[] = $hr2[$a][$b];
	    $text[] = "$a (%.0f%%)";
	}
    }

    foreach (array_keys($puzo) as $c) {
	foreach (array_keys($puzo[$c]) as $d) {
	    $data2[] = $puzo[$c][$d];
	    $text2[] = "$c (%.0f%%)";
	}
    }

    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_pie.php';

    $graph = new PieGraph(500,550,'auto');
    $graph->SetMargin(0,0,0,0);
    $graph->SetFrame(false);
    $graph->img->SetAntiAliasing();

    $graph->legend->SetPos(0.0,0.20,'right','top');
    $graph->legend->SetReverse();

    $storlek = 0.20;

    $p1 = new PiePlot($data);
    $p1->SetLabels($text);
    $p1->SetLegends($text);
    $p1->SetSize($storlek);
    $p1->SetCenter(0.25,0.35);
    $p1->SetTheme('sand');
    $p1 ->SetGuideLines (true, false);
    $p1->value->SetColor('black');
    $p1->title->Set(strings::expression("polar",
	"hr_rounded_to_tenths"));

    $p2 = new PiePlot ($data2);
    $p2->SetLabels($text2);
    $p2->SetLegends($text2);
    $p2->SetCenter(0.25,0.80);
    $p2->SetSize($storlek);
    $p2-> SetGuideLines (true, false);
    $p2->SetSliceColors(array('lightsalmon2', 
	'lightsalmon', 'lightgoldenrod', 'khaki',
	'lightcyan1', 'white'));
    $p2->title->Set(strings::expression("polar", "hrZones"));
    $p2->value->SetColor('black');

    $graph->Add($p1);
    $graph->Add($p2);

    if ( $_SESSION['tty']['enabled'] ) {
	DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	$graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	$graph->legend->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$p1->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$p1->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$p2->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$p2->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
    }

    $graph->Stroke(); 
}


function dayHeartrateZones($dateTime) {
    $workout = fileFunctions::selectFullWorkout($dateTime);

    //if ( !isset($workout['personalMaxHr']) ) {
    $maxHR = $_SESSION['maxHr'];
    /*} else {  
	$maxHR = $workout['personalMaxHr'];
    }*/

    for ($i = 0; $i < $workout["numberOfSamples"]; $i++) {
	$hrPros = 100 * ($workout["sampleHr"][$i] / $maxHR);

	if ( $hrPros < 50 ) { 
	    $hrPros = "";
	} elseif ( $hrPros > 100 ) {
	    $hrPros = 100;
	}

	$datay[] = $hrPros;
	//$datax[] = $workout['sampleDistance'][$i];
	$datax[] = makeSecond($workout['sampleTime'][$i]) / 60;

	$pz0[] = "50";
	$pz1[] = "60";
	$pz2[] = "70";
	$pz3[] = "80";
	$pz4[] = "90";
	$pz5[] = "100";
    }

    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_line.php';

    $graph = new Graph(660, 300);    
    $graph->title->Set(strings::expression("polar",
	"percent_of_maxhr")." ($maxHR)");
    $graph->SetFrame(false);
    $graph->img->SetAntiAliasing();
    $graph->SetGridDepth(DEPTH_FRONT);
    $graph->SetMargin(40,10,10,10);
    $graph->SetMarginColor('white');

    $graph->SetScale("linlin", 50, 100);

    $graph->yaxis->title->Set(strings::expression("polar",
	"percent_of_maxhr")." ($maxHR)");
    $graph->xaxis->title->Set(strings::expression("polar",
	"minutes"));
    $l = new LinePlot($datay, $datax);
    $l->SetColor("black");

    $l0colour = "white";
    $l0 = new LinePlot($pz0, $datax);
    $l0->SetColor("$l0colour");
    $l0->SetFillFromYMin(true, 0);
    $l0->SetFillColor("$l0colour");

    $l1colour = "lightcyan1";
    $l1 = new LinePlot($pz1, $datax);
    $l1->SetColor("$l1colour");
    $l1->SetFillFromYMin(true, 50);
    $l1->SetFillColor("$l1colour");

    $l2colour = "khaki1";
    $l2 = new LinePlot($pz2, $datax);
    $l2->SetColor("$l2colour");
    $l2->SetFillFromYMin(true, 60);
    $l2->SetFillColor("$l2colour");

    $l3colour = "lightgoldenrod";
    $l3 = new LinePlot($pz3, $datax);
    $l3->SetColor("$l3colour");
    $l3->SetFillFromYMin(true, 70);
    $l3->SetFillColor("$l3colour");

    $l4colour = "lightsalmon";
    $l4 = new LinePlot($pz4, $datax);
    $l4->SetColor("$l4colour");
    $l4->SetFillFromYMin(true, 80);
    $l4->SetFillColor("$l4colour");

    $l5colour = "lightsalmon2";
    $l5 = new LinePlot($pz5, $datax);
    $l5->SetColor("$l5colour");
    $l5->SetFillFromYMin(true, 90);
    $l5->SetFillColor("$l5colour");

    $graph->Add($l5);
    $graph->Add($l4);
    $graph->Add($l3);
    $graph->Add($l2);
    $graph->Add($l1);
    $graph->Add($l0);
    $graph->Add($l);

    if ( $_SESSION['tty']['enabled'] ) {
	DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	$graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	$graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$graph->xaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	$graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	$graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
    }

    $graph->Stroke();
}


function dayAltitude($dateTime) {
  $workout = fileFunctions::selectFullWorkout($dateTime);
  $datax = array();
  $datay = array();

  for ( $i = 0; $i < count($workout['sampleTime']); $i++ ) {
    $datax[] = makeSecond($workout['sampleTime'][$i]) / 60;
    $datay[] = $workout['sampleAltitude'][$i];
  }

  require $_SESSION['dirJpgraph'].'/jpgraph.php';
  require $_SESSION['dirJpgraph'].'/jpgraph_line.php';
  
  $graph = new Graph(660, 300);    
  $graph->title->Set(strings::expression("polar", "altitude"));
  $graph->img->SetAntiAliasing();
  $graph->SetFrame(false);
  $graph->SetMargin(40,10,10,10);
  $graph->SetMarginColor('white');

  $graph->SetScale("linlin");

  $graph->xaxis->title->Set(
      strings::expression("polar", "minutes"));
  $graph->yaxis->title->Set(
      strings::expression("polar", "Elevation"));
  
  $l1 = new LinePlot($datay, $datax);
  $l1->value->SetColor('black');
  $l1->value->Show(false);
  $l1->SetColor('lightsalmon4');
  $l1->SetWeight(5);
  $graph->Add($l1);

  if ( $_SESSION['tty']['enabled'] ) {
      DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
      $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
      $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
      $graph->xaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
      $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
      $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
  }

  $graph->Stroke();
  return;
} // end function dayAltitude


function monthTime($month, $year) {
	$workout = give::yearMonthWorkouts($_SESSION['workouts'], $year, $month);

  foreach ($workout as $w)
    {
      $datax[] = date("D d", $w['dateStartTime']);
      $datay[] = makeSecond($w['duration'])/60;
    }
  graf::MTime($datax, $datay);
}

function monthDistanceTime($month, $year) {
    $workout = give::yearMonthWorkouts(
	$_SESSION['workouts'], $year, $month);

    foreach ($workout as $w) {
	$datax[] = date("D d", $w['dateStartTime']);
	$datay[] = $w['distance'];
	$datay2[] = makeSecond($w['duration'])/60;
    }
    graf::DistanceTime($datax, $datay, $datay2);
}


function monthsTime() {
    $monthData = $_SESSION['monthData'];
    ksort($monthData);

    foreach (array_keys($monthData) as $x) {
	$datax[] = $x;
	$datay[] = makeSecond($monthData[$x]['time']) / 60;
    }

    graf::MTime($datax, $datay);
}


function monthsDistanceTime() {
    $monthData = $_SESSION['monthData'];
    ksort($monthData);

    foreach (array_keys($monthData) as $x) {
	$datax[] = $x;
	$datay[] = $monthData[$x]['distance'];
	$datay2[] = makeSecond($monthData[$x]['time']) / 60;
    }
    graf::DistanceTime($datax, $datay, $datay2);
}



function monthKCal($month, $year) {
	$workout = give::yearMonthWorkouts($_SESSION['workouts'], $year, $month);
  $energy_total = 0;

  foreach ($workout as $w)
    {
      $datax[] = date("D d", $w['dateStartTime']);
      $datay[] = $w['energy'];
      $energy_total = $energy_total + $w['energy'];

     }
  graf::energy($datax, $datay, $energy_total);
} // end function monthKCal



function monthsKCal() {
  $monthData = $_SESSION['monthData'];
  ksort($monthData);
  $energy_total = 0;
 
  foreach (array_keys($monthData) as $x)
    {
      $datax[] = $x;
      $datay[] = $monthData[$x]['energy'];
      $energy_total += $monthData[$x]['energy'];
    }
  
  graf::energy($datax, $datay, $energy_total);
  
}


function monthAvgMaxSpeed($month, $year) {
	$workouts = give::yearMonthWorkouts($_SESSION['workouts'], $year, $month);

	foreach ( $workouts as $w ) {
		$datax[] = date("D d", $w['dateStartTime']);
		$dataMaxSpeed[] = $w['speedMax'];
		$dataAvgSpeed[] = $w['speedAvg'];
		$speedUnit = $w['unitSpeed'];
	}
	graf::speedAvgMax($datax, $dataMaxSpeed, $dataAvgSpeed, $speedUnit);
}

function monthsAvgMaxSpeed() {
  $monthData = $_SESSION['monthData'];
  ksort($monthData);
 
  foreach (array_keys($monthData) as $x) {
	    $datax[] = $x;
	    $dataMaxSpeed[] = $monthData[$x]['speedMax'];
	    $dataAvgSpeed[] = $monthData[$x]['speedAvg'];
	    $speedUnit = $monthData[$x]['speedUnit'];
    }

  graf::speedAvgMax($datax, $dataMaxSpeed, $dataAvgSpeed, $speedUnit);

} // end function monthsAvgMaxSpeed

function monthsAvgMaxMinDistance() {
  $monthData = $_SESSION['monthData'];
  ksort($monthData);
 
  foreach (array_keys($monthData) as $x) {
	    $datax[] = $x;
	    $dataAvgDis[] = $monthData[$x]['avgDistance'];
	    $dataMaxDis[] = $monthData[$x]['maxDistance'];
	    $dataMinDis[] = $monthData[$x]['minDistance'];
    }

  graf::distanceAvgMaxMin($datax, $dataMaxDis, $dataAvgDis, $dataMinDis);

} // end function monthsAvgMaxMin


function monthsAvgMaxMinTime() {
  $monthData = $_SESSION['monthData'];
  ksort($monthData);
 
  foreach (array_keys($monthData) as $x) {
	    $datax[] = $x;
	    $avgTime[] = makeSecond($monthData[$x]['avgTime']) / 60;
	    $maxTime[] = makeSecond($monthData[$x]['maxTime']) / 60;
	    $minTime[] = makeSecond($monthData[$x]['minTime']) / 60;
    }

  graf::timeAvgMaxMin($datax, $maxTime, $avgTime, $minTime);
} // end function monthsAvgMaxMinTime

class graf {

	function timeAvgMaxMin($datax, $maxTime, $avgTime, $minTime) {
		require($_SESSION['dirJpgraph'].'/jpgraph.php');
		require($_SESSION['dirJpgraph'].'/jpgraph_line.php');
		require($_SESSION['dirJpgraph'].'/jpgraph_bar.php');

		$graph = new Graph(600, 200, "auto");
		$graph->SetScale("textlin");
		$graph->img->SetAntiAliasing(true);
    		$graph->SetMargin(55,55,30,45);
    		$graph->SetMarginColor('azure');
		$graph->legend->Pos(0.012, 0.025, "right", "top");
		$graph->SetColor("white");
		$graph->title->Set(strings::expression("polar", "time"));

		$graph->xaxis->SetTickLabels($datax);
		$graph->yaxis->title->Set(strings::expression("polar", "minutes"));

		$lMax = new LinePlot($maxTime);
		$lMax->SetColor("skyblue1");
		$lMax->SetFillColor("skyblue1");
		$lMax->SetLegend(strings::expression("common", "MaximumAbbrev"));
    		//$lMax->value->Show();
    		//$lMax->value->SetFormat("%0.0f");  
		$graph->Add($lMax);

		$lAvg = new LinePlot($avgTime);
		$lAvg->SetFillColor("skyblue3");
		$lAvg->SetLegend(strings::expression("common", "AverageAbbrev"));
		$graph->Add($lAvg);

		$lMin = new LinePlot($minTime);
		$lMin->SetFillColor("skyblue4");
		$lMin->SetLegend(strings::expression("common", "MinimumAbbrev"));
		$graph->Add($lMin);

		if ( $_SESSION['tty']['enabled'] ) {
			  DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
			  $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
			  $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
			  $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
			  $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
			  $graph->yaxis->SetTitleMargin(40);
	  $graph->xaxis->SetLabelAngle(45);
		  }

		$graph->Stroke();
	} // end function timeAvgMaxMin


	function distanceAvgMaxMin($datax, $dataMaxDis, $dataAvgDis, $dataMinDis) {
		require($_SESSION['dirJpgraph'].'/jpgraph.php');
		require($_SESSION['dirJpgraph'].'/jpgraph_line.php');
		require($_SESSION['dirJpgraph'].'/jpgraph_bar.php');

		$graph = new Graph(600, 200, "auto");
		$graph->SetScale("textlin");
		$graph->img->SetAntiAliasing(true);
    		$graph->SetMargin(55,55,30,45);
    		$graph->SetMarginColor('azure');
		$graph->SetColor("white");
		$graph->legend->Pos(0.012, 0.025, "right", "top");
		$graph->title->Set(strings::expression("polar", "distance"));

		$graph->xaxis->SetTickLabels($datax);
		$graph->yaxis->title->Set(strings::expression("polar", "kilometers"));

		$lMax = new LinePlot($dataMaxDis);
		$lMax->SetColor("skyblue1");
		$lMax->SetFillColor("skyblue1");
		$lMax->SetLegend(strings::expression("common", "MaximumAbbrev"));
    		//$lMax->value->Show();
    		//$lMax->value->SetFormat("%0.0f");  
		$graph->Add($lMax);

		$lAvg = new LinePlot($dataAvgDis);
		$lAvg->SetFillColor("skyblue3");
		$lAvg->SetLegend(strings::expression("common", "AverageAbbrev"));
		$graph->Add($lAvg);

		$lMin = new LinePlot($dataMinDis);
		$lMin->SetFillColor("skyblue4");
		$lMin->SetLegend(strings::expression("common", "MinimumAbbrev"));
		$graph->Add($lMin);

		if ( $_SESSION['tty']['enabled'] ) {
			  DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
			  $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
			  $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
			  $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
			  $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
			  $graph->yaxis->SetTitleMargin(40);
	  $graph->xaxis->SetLabelAngle(45);
		  }
		$graph->Stroke();
	} // end function distanceAvgMaxMin

	function speedAvgMax($datax, $dataMaxSpeed, $dataAvgSpeed, $speedUnit) {
		require($_SESSION['dirJpgraph'].'/jpgraph.php');
		require($_SESSION['dirJpgraph'].'/jpgraph_line.php');
		require($_SESSION['dirJpgraph'].'/jpgraph_bar.php');

		$graph = new Graph(600, 200, "auto");
		$graph->SetScale("textlin");
		$graph->img->SetAntiAliasing(true);
    		$graph->SetMargin(55,55,30,45);
    		$graph->SetMarginColor('azure');
		$graph->legend->Pos(0.012, 0.025, "right", "top");
		$graph->SetColor("white");
		if ( isset($_GET['m']) ) {
			$graph->title->Set(strings::expression("polar", "speed"));
		} else {
			$graph->title->Set(strings::expression("polar", "speed").", ".strings::expression("common", "average"));
		}

		$graph->xaxis->SetTickLabels($datax);
		$graph->yaxis->title->Set($speedUnit);

		if ( isset($_GET['m']) && isset($_GET['y']) ) {
			$lMax = new LinePlot($dataMaxSpeed);
			$lMax->SetColor("skyblue1");
			$lMax->SetFillColor("skyblue1");
			$lMax->SetLegend(strings::expression("common", "MaximumAbbrev"));
			//$lMax->value->Show();
			//$lMax->value->SetFormat("%0.0f");  
			$graph->Add($lMax);
		}

		$lAvg = new LinePlot($dataAvgSpeed);
		$lAvg->SetFillColor("skyblue3");
		if ( isset($_GET['m']) ) {
			$lAvg->SetLegend(strings::expression("common", "AverageAbbrev"));
		}
		$graph->Add($lAvg);

		if ( $_SESSION['tty']['enabled'] ) {
			  DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
			  $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
			  $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
			  $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
			  $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
			  $graph->yaxis->SetTitleMargin(40);
	  $graph->xaxis->SetLabelAngle(45);
		  }
		$graph->Stroke();
	} // end function speedAvgMax

  function energy ($datax, $datay, $energy_total) {
    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_line.php';

    
    $graph = new Graph(600,200,"auto");
    $graph->img->SetAntiAliasing();
    $graph->title->Set(strings::expression("polar", "energySpendage")." (".$energy_total." KCal tot.)");
    $graph->SetMargin(55,30,30,45);
    $graph->SetMarginColor('azure');
    $graph->SetColor('white');
    
    $graph->SetScale("textlin");
    
    $graph->xaxis->SetTickLabels($datax);
    $graph->xaxis->SetLabelAngle(90);
    $graph->xaxis->HideTicks(true, true);
    
    $graph->yaxis->title->Set(strings::expression("polar", "kcal"));
    
    $p1 = new LinePlot($datay);
    $p1->value->Show();
    $p1->value->SetFormat("%0.0f");  
    $p1->value->SetColor('black');
    $graph->Add($p1);
    
  if ( $_SESSION['tty']['enabled'] ) {
	  DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	  $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	  $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	  $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $graph->yaxis->SetTitleMargin(40);
	  $p1->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $p1->value->SetAngle(45);
	  $graph->xaxis->SetLabelAngle(45);
  }
  
    $graph->Stroke(); 
  } // end function energy
  
  function MTime($datax, $datay) {
    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_bar.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_line.php';
    
    $graph = new Graph(600,250,"auto");
    $graph->img->SetAntiAliasing();
    $graph->title->Set(strings::expression("polar", "time"));
    $graph->SetMargin(45,30,30,45);
    $graph->SetMarginColor('azure');
    $graph->SetColor('white');
    
    $graph->SetScale("textlin");
    
    $graph->xaxis->SetTickLabels($datax);
    $graph->xaxis->SetLabelAngle(90);
    $graph->xaxis->HideTicks(true, true);
    
    $graph->yaxis->title->Set(strings::expression("polar", "minutes"));
    
    $p1 = new BarPlot($datay);
    $p1->value->Show();
    $p1->value->SetAngle(90);  
    $p1->SetFillColor("azure3");
    $p1->value->SetColor('black');
    $p1->SetWidth(0.7);
    $p1->value->SetFormat("%0.0f");  
    $p1->SetValuePos("bottom");
    $graph->Add($p1);
    
  if ( $_SESSION['tty']['enabled'] ) {
	  DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	  $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	  $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	  $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $p1->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $p1->value->SetAngle(45);
	  $graph->xaxis->SetLabelAngle(45);
  }
  
    $graph->Stroke(); 
    
  } // end function MTime
  
  function DistanceTime($datax, $datay, $datay2) {
    require $_SESSION['dirJpgraph'].'/jpgraph.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_bar.php';
    require $_SESSION['dirJpgraph'].'/jpgraph_line.php';
    
    $graph = new Graph(600,250,"auto");
    $graph->img->SetAntiAliasing();
    $graph->title->Set(strings::expression("polar",
	"distance_and_time").", ".strings::expression("polar",
	"total"));
    $graph->SetMargin(45,45,30,45);
    $graph->SetMarginColor('azure');
    $graph->SetColor('white');
    
    $graph->SetScale("textlin");
    $graph->SetY2Scale("int");
    
    $graph->xaxis->SetTickLabels($datax);
    $graph->xaxis->SetLabelAngle(90);
    $graph->xaxis->HideTicks(true, true);
    
    $graph->yaxis->title->Set(strings::expression("polar", "distance"));
    $graph->y2axis->title->Set(strings::expression("polar", "minutes"));
    
    $p1 = new BarPlot($datay);
    $p1->value->Show();
    $p1->value->SetAngle(90);  
    $p1->SetFillColor("azure3");
    $p1->value->SetColor('black');
    $p1->SetWidth(0.7);
    $p1->SetValuePos("bottom");
    $graph->Add($p1);
    
    $p2 = new LinePlot($datay2);
    $p2->SetBarCenter();
    $p2->value->Show();
    $p2->value->SetFormat("%0.0f");  
    $p2->value->SetColor('black');
    $p2->SetColor('darkred');
    $p2->SetWeight(2.5);
    $graph->SetY2OrderBack(false); 
    $graph->AddY2($p2);
    
  if ( $_SESSION['tty']['enabled'] ) {
	  DEFINE( "TTF_DIR", $_SESSION['dirTTY'] );
	  $graph->title->SetFont(FF_ARIAL, FS_BOLD, 12);
	  $graph->yaxis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	  $graph->y2axis->title->SetFont(FF_ARIAL, FS_NORMAL, 10);
	  $graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $graph->yaxis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $graph->y2axis->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $p1->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $p2->value->SetFont(FF_ARIAL, FS_NORMAL, 8);
	  $p1->value->SetAngle(45);
	  $graph->xaxis->SetLabelAngle(45);
  }
  
    $graph->Stroke(); 
    
  } // end function DistanceTime
  
} // end class graf


?>
