<?php 
/**
* @version 00.04.03
* @package polaring
* @license This component in released under the GNU/GPL License
*
* File: view/day.php
* Role: Returns information about specific day.
*
**/

function showDay($dateTime) {
    $phpindex = $_SESSION['phpindex']."&amp;section=polar";

    $w = $_SESSION['workouts'][$dateTime];
    /*echo "<pre>\n";
    print_r(fileFunctions::selectFullWorkout($dateTime));
    echo "</pre>\n";*/
    $month = date("m",$w["dateStartTime"]);
    $year = date("Y",$w["dateStartTime"]);

    visa::backLink($_REQUEST);

    $trDatum = date("D, d M Y, H:i", $w['dateStartTime']);

    echo "<h2>".$trDatum."</h2>\n";
    echo " <table class=\"dag\" >\n" .
	"  <tfoot>\n".
	"    <tr>\n".
	"      <td><p><a href=\"".$phpindex.
	"&amp;mission=samples&amp;dateTime=".$dateTime."\">".
	strings::expression("polar", "viewSamples").
	"</a></p></td>\n".
	"    </tr>\n".
	"  </tfoot>\n".
	"  <tbody>\n";
    $writeRow = array(
	strings::expression("polar", "time").": ".$w['duration']);
    if ( $w['distance'] > 0 ) {
	$writeRow[] = strings::expression("polar", "distance").
	    ": ".$w['distance']." ".$w['unitDistance'];
    }
    if ( $w['ascent'] > 0 || $w['ascent'] < 0 ) {
	$writeRow[] = strings::expression("polar", "ascent").
	    ": ".round($w['ascent'], 1)." ".$w['unitAltitude'];
    }
    if ( $w['speedAvg'] > 0 ) {
	$writeRow[] = strings::expression("polar", "speedAvgMax").
	    ": ".round($w['speedAvg'], 2)."/".round($w['speedMax'],
	       2)." ".$w['unitSpeed'];
    }
    if ( $w['altitudeAvg'] != 0 ) {
	$writeRow[] = strings::expression("polar", 
	    "altitudeAvgMax").": ".round($w['altitudeAvg'], 1)."/"
	    .round($w['altitudeMax'], 1)." ".$w['unitAltitude'];
    }
    if ( $w['hrAvg'] > 0 ) {
	$writeRow[] = strings::expression("polar", "hrAvgMax").
	    ": ".$w['hrAvg']."/".$w['hrMax']." ".$w['unitHr'];
    }
    if ( $w['energy'] > 0 ) {
	$writeRow[] = strings::expression("polar", "energy").
	    ": ".$w['energy']." ".$w['unitEnergy'];
    }
    if ( $w['temperatureAvg'] != 0 ) {
	$writeRow[] = strings::expression("polar",
	    "temperatureAvgMax").": ".$w['temperatureAvg']."/"
	    .$w['temperatureMax']." ".$w['unitTemperature'];
    }

    foreach ($writeRow as $rad) {
	list($text, $value) = split(': ', $rad);
	echo "    <tr>\n" .
	    "      <td class=\"headline\"><p>".$text."</p></td>\n" .
	    "      <td class=\"right\" ><p>".$value."</p></td>\n" .
	    "    </tr>\n";
    }

    echo "  </tbody>\n" .
	" </table>\n";

    /***********\
     * GRAPHS
    \***********/

    echo "<h2>".strings::expression("polar", "graphs").
	"</h2>\n<hr />\n";

    echo "<table class=\"center day\" width=\"100%\" border=\"0\">\n".
	"  <thead>\n";
    if ( isset($_REQUEST['selGraph']) ) {
	echo "    <tr>\n      <td colspan=\"2\" class=\"center\">";
	visa::graphLinkMedium($_REQUEST['selGraph']);
	echo "</td>\n    </tr>\n";
    }
    echo "  </thead>\n  <tfoot>\n    <tr>\n      <td colspan=\"2\" ".
	"class=\"center\"><p>(".strings::expression("polar", 
	"ClickToEnlargeGraph").")</p></td>\n    </tr>\n  </tfoot>\n".
	"  <tbody>\n";

    $_SESSION['nGraphs'] = 0;

    // Google Maps
    if ( $w['sampleLocationLat']['0'] ) {
	visa::graphLinkSmall("dayGmapRoute",
	    strings::expression("polar", "Map"), "350", "150");
	//gmaps::mapDiv();
    } 

    // heartrate and distance
    if ( $w['hrAvg'] > 0 ) {
	if ( $w['distance'] > 0 ) {
	    visa::graphLinkSmall("dayHeartrateSpeed",
		strings::expression("polar", "hr_and_speed"),
		"330", "150");
	} else {
	    visa::graphLinkSmall("dayHeartrate",
		strings::expression("polar", "hr"),
		"330", "150");
	}
    }
    // altitude
    if ( $w['ascent'] != 0 ) {
	visa::graphLinkSmall("dayAltitude",
	    strings::expression("polar", "altitude"),
	    "330", "150");
    }
    // heartrate-zones
    if ( $w['hrAvg'] > 0 ) {
	// heartrate in zones
	visa::graphLinkSmall("dayHeartrateZones",
	    strings::expression("polar", "percent_of_maxhr"),
	    "330", "150");
	// heartrate in zones (pie-graph)
	visa::graphLinkSmall("dayHeartratePies",
	    strings::expression("polar", "hr_rounded_to_tenths").
	    " &amp; ".strings::expression("polar", "hrZones"),
            "150", "165");
    }

    echo "  </tbody>\n</table>\n";

    visa::backLink($_REQUEST);

    return(true);
}
?>
